<!--- 
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the PT Blog directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2012.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files 
in this directory, you agree to the terms and conditions of the applicable 
end user license agreement.
--->

<!---
/* *************************************************************** */
Author: 	
	PaperThin, Inc.
	Ron West
Name:
	blog_post_display.cfm
Summary:	
	Render Handler that displays the main blog post details
ADF App:
	PT Blog
Version:
	2.2
History:
	2009-05-28 - RLW - Created
	2010-10-28 - MFC - Updated to resolve bug with first comment not rendering.
	2011-10-21 - MFC - Updated logic for comment validation.
	2011-10-28 - MFC - Added Feature - PT tags integration into the blog post.
	2011-11-22 - MFC - Changed the custom metadata form name to "blogs2".
	2012-02-28 - DMB - Bug fix.  Changed "request.page.metadata.blogs" references to "request.page.metadata.blogs2" to match metadata form name.
	2012-02-28 - DMB - Changed "content" class to "blogcontent" to avoid matching on customer CSS.
	2012-09-11 - MFC - Added the blog post creator as the By Line in the display.
					   Fixed bug with loading the tag data in the blog post.
--->
<cfparam name="request.page.metadata.blogs2.postID" default="0">
<cfscript>
	blogData = structNew();
	comments = arrayNew(1);
	// TODO remove after development is completed
	request.element.isStatic = 0;
	blogDataArray = attributes.elementInfo.elementData.propertyValues;
	if( arrayLen(blogDataArray) )
	{
		blogData = blogDataArray[1].values;
		blogData.dataPageID = blogDataArray[1].pageID;
	}
	blogFormID = application.ptBlog2.getBlogFormID();
	
	commentsFormID = application.ptBlog2.getCommentsFormID();
	comments = application.ptBlog2.commentsDAO.getCommentsByContentID(request.page.metadata.blogs2.postID, commentsFormID, "dateCreated", "desc");
	
	// Get the contact data for the user who posted the blog
	if ( StructKeyExists(blogData, "createdBy") AND LEN(blogData.createdBy) )
		contactQry = application.ptBlog2.csData.getContactData(userID=blogData.createdBy);
	else
		contactQry = QueryNew("null");
	
	application.ptBlog2.scripts.loadJQuery();
	application.ptBlog2.scripts.loadJQueryUI();
</cfscript>

<!--- <cfdump var="#comments#" expand="false">  --->
<!--- <cfdump var="#blogData#" expand="false">
<cfdump var="#contactQry#"> --->
<cfif listLen(structKeyList(blogData))>
	<cfscript>
		// Check if comments are allowed
		if ( blogData.allowComments EQ 1 )
			renderComments = true;
		else
			renderComments = false;
	</cfscript>
	<cfoutput>
	<style>
		div.blog-post-display {
			margin: 20px;
		}
		div.blog-post-display-comments {
			margin: 20px;	
		}
		div.blog-post-display-comment-form {
			margin: 20px;	
		}
		div.blog-post-display-comment-form .row {
			margin-top: 5px;	
		}
	</style>
	<script type="text/javascript">
		jQuery("document").ready( function($){
			// bind action to the submit button
			jQuery("##submit").bind("click", submitComment);
		});
		function submitComment(){
			
			// Flag to determin if we fields are completed to submit the comment
			var submitComment = false;
			// Check if the required fields are entered
			var commentName = jQuery("##author").attr("value");
			var commentEmail = jQuery("##email").attr("value");
			var commentURL = jQuery("##url").attr("value");
			var commentText = jQuery("##comment").attr("value");
			var responseMsg = "";
			
			
			if ( commentName.length <= 0 )
				responseMsg = "Please enter your Name to submit a comment.";
			else if ( commentEmail.length <= 0 )
				responseMsg = "Please enter your E-Mail to submit a comment.";
			else if ( commentText.length <= 0 )
				responseMsg = "Please enter your comment.";
			else {
				responseMsg = "Comment submitted successfully";
				submitComment = true;
			}
			
			if ( submitComment ){
				// hide the submit button
				jQuery("##submit").hide();
				// show the message for loading
				jQuery("##submitting").show();
				// submit the form
				jQuery.post("#application.ADF.ajaxProxy#",
					{ 	bean: "commentsService",
						method: "handleCommentsSubmit",
						contentPageID: "#request.page.metadata.blogs2.postID#",
						comments: commentText,
						name: commentName,
						email: commentEmail,
						blogURL: commentURL,
						formID: "#blogFormID#",
						returnFormat: "json" },
					function( response ){
						// hide the "submitting" message
						jQuery("##submitting").hide();
						// reshow the submit button
						jQuery("##submit").show("blind", {}, 500);
						results = eval( '(' + response + ')' );
						if ( results == 'require-approval' ) // Check if comments req approval
							responseMsg = "Your comment has been saved.  Comments require approval before being displayed.";
						else if( !results.length ) // check for correct results
							responseMsg = "Error posting comment - please refresh page and try again";
						else {
							jQuery("##thecomments").prepend(results);
							// Check if the comments block is hidden, then show
							if( jQuery("div##comments").is(':hidden') )
								jQuery("div##comments").show("blind", {}, 1000);
						}
						jQuery("##submitted").html(responseMsg);
						jQuery("##submitted").show("highlight", {}, 1500);
						jQuery("##submitted").hide("highlight", {}, 2500);
						// clear the form
						jQuery("##comment").attr("value", "");
						jQuery("##author").attr("value", "");
						jQuery("##email").attr("value", "");
						jQuery("##url").attr("value", "");
					}
				);
			}
			else {
				jQuery("##submitted").html(responseMsg);
				jQuery("##submitted").show("highlight", {}, 1500);
			}
		}
	</script>
	<div class="blog-post-display">
		<h2>#blogData.title#</h2>
		<!--- Display the By Line --->
		<cfif contactQry.recordCount>
			<div class="blog-by-line">
				By #contactQry.FirstName# #contactQry.LastName# 
			</div>
		</cfif>
		<div class="info">
			<span class="date">#dateFormat(blogData.datePosted, "mmmm dd, yyyy")#</span>
			<!--- <div class="act">
				<span class="comments"><a href="##comments">Goto comments</a></span>
				<span class="addcomment"><a href="##respond">Leave a comment</a></span>
				<div class="fixed">&nbsp;</div>
			</div> --->
			<div class="fixed">&nbsp;</div>
		</div>
		<div class="blogcontent">
		#blogData.content#
		</div>
		
		<!--- 2011-10-28 - MFC - Added Feature - PT tags integration into the blog post. --->
		<!--- Display the tags for the post --->
		<cfif structKeyExists(blogData, "tags") and LEN(blogData.tags)>
			<!--- Check if the PT Tags apps is integrated --->
			<cfif application.ptBlog2.appConfig.tagsIntegrated
					AND ListFindNoCase(application.ADF.siteAppList, "ptTags") >
				
				<!--- Set the blog landing page URL --->
				<cfset blogLandingPageURL = application.ptBlog2.blogService.getFeatureCSPageURL(blogID=blogData.blogID, featureType="landingPage")>
				<!--- // retrieve the names for the tags --->
				<cfset tagNameList = application.ptTags.tagsService.tagNameListByIDs(tagIDList=blogData.tags, anchorHref=blogLandingPageURL)>
			<cfelse>
				<cfset tagNameList = blogData.tags>
			</cfif>
			<p class="under"><span class="tags"><strong>Tags:</strong> <em>#replace(tagNameList, "^", ", ", "all")#</em></span></p>
		</cfif>
	</div>
	<cfif renderComments>
		<cfset commentHTML = application.ptBlog2.commentsService.getCommentsHTML(comments)>
		<!--- Check if the return is "require-comments" then clear the variable
				b/c we don't want to render this.
		 --->
		<cfif commentHTML EQ "require-approval">
			<cfset commentHTML = "">
		</cfif>
		
		<!--- If no comments then hide the comments html section --->
		<cfif ( LEN(commentHTML) LTE 0 )>
			<style>
				div##comments {
					display: none;
				}
			</style>
		</cfif>
			
		<div id="comments" class="blog-post-display-comments">
			<!--- <div id="cmtswitcher">
				<a onclick="MGJS.switchTab('thecomments,commentnavi', 'thetrackbacks', 'commenttab', 'curtab', 'trackbacktab', 'tab');" href="javascript:void(0);" class="curtab" id="commenttab">Comments (#arrayLen(comments)#)</a>
				<!--- <a onclick="MGJS.switchTab('thetrackbacks', 'thecomments,commentnavi', 'trackbacktab', 'curtab', 'commenttab', 'tab');" href="javascript:void(0);" class="tab" id="trackbacktab">Trackbacks (0)</a> --->
				<span class="addcomment"><a href="##respond">Leave a comment</a></span>
				<!--- <span class="addtrackback"><a href="http://www.notronwest.com/blog/2007/10/23/we-need-to-increase-the-rate-at-which-we-consume-information/trackback/">Trackback</a></span> --->
				<div class="fixed">&nbsp;</div>
			</div> --->
			<h3>Comments</h3>
			<div class="fixed">&nbsp;</div>
			<div id="commentlist">
				<!-- comments START -->
				<ol id="thecomments">
					#commentHTML#
				</ol>
				<!-- comments END -->
				<!-- trackbacks START
				<ol id="thetrackbacks">
					<li class="messagebox">No trackbacks yet.</li>
				</ol> -->
				<div class="fixed">&nbsp;</div>
				<!-- trackbacks END -->
			</div>
		</div>
		
		<div class="blog-post-display-comment-form">
			<h3>Post A Comment</h3>
			<form id="commentform">
				<div id="submitted" style="display:none;"></div>
				<div id="respond">
					<div id="author_info">
						<div class="row">
							<input type="text" tabindex="1" size="24" value="" class="textfield" id="author" name="author"/>
							<label class="small" for="author">Name (required)</label>
						</div>
						<div class="row">
							<input type="text" tabindex="2" size="24" value="" class="textfield" id="email" name="email"/>
							<label class="small" for="email">E-Mail (will not be published) (required)</label>
						</div>
						<div class="row">
							<input type="text" tabindex="3" size="24" value="" class="textfield" id="url" name="url"/>
							<label class="small" for="url">Website</label>
						</div>
					</div>
				
					<!-- comment input -->
					<div class="row">
						<textarea cols="50" rows="8" tabindex="4" id="comment" name="comment"></textarea>
					</div>
					
					<div class="row">
						<!-- comment submit and rss -->
						<div id="submitbox">
							<!--- <a href="<!--- // TODO need RSS feed link --->" class="feed">Subscribe to comments feed</a> --->
							<div class="floatright">
								<input type="button" value="Submit Comment" tabindex="5" class="button" id="submit" name="submit"/>
								<div id="submitting" style="display:none;">Submitting comments..<img src="/ADF/lib/ajax/images/ajax-loader-arrows.gif" align="absmiddle" /></div>
							</div>
							<input type="hidden" value="172" name="comment_post_ID"/>
							<div class="fixed">&nbsp;</div>
						</div>	
					</div>
				</div>
			</form>
		</div>
	</cfif>
	</cfoutput>
</cfif>
	<!--- <div id="postnavi">
	<span class="prev"><a href="http://www.notronwest.com/blog/2007/11/02/horizon-of-social-network-applications-is-expanding/">Horizon of Social Network Applications is expanding</a></span>
	<span class="next"><a href="http://www.notronwest.com/blog/2007/10/09/commentary-110-is-not-a-bad-thing/">Commentary: 110% is not a bad thing</a></span>
	<div class="fixed">&nbsp;</div>
</div> --->
